import { Type, TypeChecker as RawTypeChecker } from "typescript";
export declare type TypeChecker = RawTypeChecker & {
    readonly isTypeAssignableTo?: (type1: Type, type2: Type) => boolean;
};
export declare type TypePairArray = ReadonlyArray<{
    readonly destinationType: Type;
    readonly sourceType: Type;
}>;
/**
 * Throws away non-object types (string, number, boolean, etc) because we don't check those for readonly -> mutable assignment
 * and returns an array of pairs of types that are assignable.
 */
export declare const assignableObjectPairs: (rawDestinationType: Type, rawSourceType: Type, checker: TypeChecker) => TypePairArray;
